﻿using System;
using System.IO;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace ABetterJsonExperience
{
    class Program
    {
        static void Main(string[] args)
        {
            Program p = new Program();

            string awsPolicyJson = p.GetAWSElasticSearchPolicy("us-east-1", "123456789", "my-test-domain", "1.1.1.1");
            Console.WriteLine(awsPolicyJson);
        }

        private string GetAWSElasticSearchPolicy(string region, string account, string elasticSearchDomainName, string allowedIPAddress)
        {
            string blankPolicy = File.ReadAllText("AWSPolicy.json");
            dynamic awsElasticSearchPolicy = JsonConvert.DeserializeObject(blankPolicy);

            awsElasticSearchPolicy.Statement[0].Resource = $"arn:aws:es:{region}:{account}:domain/{elasticSearchDomainName}/*";
            awsElasticSearchPolicy.Statement[0].Condition.IpAddress = new JObject(new JProperty("aws:SourceIp", allowedIPAddress));

            return awsElasticSearchPolicy.ToString();
        }
    }
}
